#include <fstream.h>
#include "global.h"
#include "init.h"
#include "inout.h"
#include "solver.h"

void main()
   {
   real rmax;
   int i,tn;
   
   ofstream resi("resi.plt");
   
   input("in.dat");
   
   Matrix<real> vol(imp2,jmp2),x(imp2,jmp2),y(imp2,jmp2),dt(imp2,jmp2),
          surf1[2]   = {Matrix<real>(imp2,jmp2),Matrix<real>(imp2,jmp2)},
          surf2[2]   = {Matrix<real>(imp2,jmp2),Matrix<real>(imp2,jmp2)},
          flux1[2][4]={{Matrix<real>(imp2,jmp2),Matrix<real>(imp2,jmp2),
                        Matrix<real>(imp2,jmp2),Matrix<real>(imp2,jmp2)},
                       {Matrix<real>(imp2,jmp2),Matrix<real>(imp2,jmp2),
                        Matrix<real>(imp2,jmp2),Matrix<real>(imp2,jmp2)}},
          flux2[2][4]={{Matrix<real>(imp2,jmp2),Matrix<real>(imp2,jmp2),
                        Matrix<real>(imp2,jmp2),Matrix<real>(imp2,jmp2)},
                       {Matrix<real>(imp2,jmp2),Matrix<real>(imp2,jmp2),
                        Matrix<real>(imp2,jmp2),Matrix<real>(imp2,jmp2)}},
            dflux1[4]= {Matrix<real>(imp2,jmp2),Matrix<real>(imp2,jmp2),
                        Matrix<real>(imp2,jmp2),Matrix<real>(imp2,jmp2)},
            dflux2[4]= {Matrix<real>(imp2,jmp2),Matrix<real>(imp2,jmp2),
                        Matrix<real>(imp2,jmp2),Matrix<real>(imp2,jmp2)},
                 R[4]= {Matrix<real>(imp2,jmp2),Matrix<real>(imp2,jmp2),
                        Matrix<real>(imp2,jmp2),Matrix<real>(imp2,jmp2)},
                 W[5]= {Matrix<real>(imp2,jmp2),Matrix<real>(imp2,jmp2),
                        Matrix<real>(imp2,jmp2),Matrix<real>(imp2,jmp2),
                        Matrix<real>(imp2,jmp2)},
              Wold[4]= {Matrix<real>(imp2,jmp2),Matrix<real>(imp2,jmp2),
                        Matrix<real>(imp2,jmp2),Matrix<real>(imp2,jmp2)};
   
   vol=x=y=dt=0;
   surf1[0]=surf1[1]=surf2[0]=surf2[1]=0;
   flux1[0][0]=flux1[0][1]=flux1[0][2]=flux1[0][3]=0;
   flux1[1][0]=flux1[1][1]=flux1[1][2]=flux1[1][3]=0;
   flux2[0][0]=flux2[0][1]=flux2[0][2]=flux2[0][3]=0;
   flux2[1][0]=flux2[1][1]=flux2[1][2]=flux2[1][3]=0;
   dflux1[0]=dflux1[1]=dflux1[2]=dflux1[3]=0;
   dflux2[0]=dflux2[1]=dflux2[2]=dflux2[3]=0;
   R[0]=R[1]=R[2]=R[3]=0;
   W[0]=W[1]=W[2]=W[3]=0;
    
   init(W,x,y);
   metric(x,y,vol,surf1,surf2);
   boundary(W,flux1,flux2,vol);

   
   printf("    step         loc.         val.      of max. Residual\n\n");
   tn=0; rmax=1;
   while(rmax>1e-7)
      {
      timestep(W,x,dt);
      march(W,Wold,vol,surf1,surf2,flux1,flux2,dflux1,dflux2,R,dt);
      if(!(tn%100))
         {
         printf("%8d        %4d     %10.3g\n",tn,i,rmax=R[0].row(2).maximum(i));
         resi<<tn<<"   "<<rmax<<"\n";   
         }
      tn++;
      }
   
   output("out.plt",x,W,dflux1);
   }
   
   
       
