#include <fstream.h>
#include "global.h"

void input(char* filename)
   {
   char z[100];
   ifstream infile(filename);
   
   
   infile.getline(z,sizeof z);
   infile >> ndim >> im >> jm;
   infile.getline(z,sizeof z);
   
   imp1=im+1; jmp1=jm+1;
   imp2=im+2; jmp2=jm+2;

   infile.getline(z,sizeof z);
   infile >> CFL;
   infile.getline(z,sizeof z);
   
   infile.getline(z,sizeof z);
   infile >> gam >> cp;
   infile.getline(z,sizeof z);
   
   cv=cp/gam; gamR=gam*(cp-cv);
   
   infile.getline(z,sizeof z);
   infile >> kap2 >> kap4;
   infile.getline(z,sizeof z);

   infile.getline(z,sizeof z);
   infile >> P0i >> T0i >> pe;
   
   cout<<" Number of Dimensions:    "<<ndim<<endl;
   cout<<" Gridsize:                "<<im<<" x "<<jm<<endl;
   cout<<" CFL-Number:              "<<CFL<<endl;
   cout<<" gamma, cp:               "<<gam<<"   "<<cp<<endl;
   cout<<" kappa2, kappa4           "<<kap2<<"   "<<kap4<<endl;
   cout<<" Total Inlet Pressure:    "<<P0i<<endl;
   cout<<" Total Inlet Temperature: "<<T0i<<endl;
   cout<<" Static Exit Pressure:    "<<pe<<endl<<endl;
   }

void output(char* filename, Matrix<real>& x, Matrix<real>* W, Matrix<real>* dflux1)
   {
   ofstream outfile(filename);
   
   int i;
   real X;
   
   for(i=1;i<=imp2;i++)
      {
      X=(i>1 && i<imp2) ? 0.5*(x(i,2)+x(i-1,2)) : x(i,2);
      outfile<<X<<"    "<<W[0](i,2)
                <<"    "<<W[1](i,2)/W[0](i,2)
                <<"    "<<W[3](i,2)/W[0](i,2)
                <<"    "<<W[4](i,2)
                <<"\n";
      }               
   }                        
