#include <math.h>
#include <fstream.h>

double area(double x);
double mach2(double m1);
double ptot2(double p01,double m1);
double pstat(double p0,double m);
double mach_a(double a,double m0);
double a_mach(double m);

void main()
   {
   double x,dx,xs,m,m1,m2,p,pe,p01,p02,a;
   int nix;

   ofstream outfile("p.plt");
   
   dx=0.05;
   cout<<"shock location: ";
   cin>>xs;
   p01=10.;
   
   for(x=0;x<xs+0.5*dx && x<10.+0.5*dx;x+=dx)
      {
      a=area(x);
      m=mach_a(a,0.1+2.*(x>5.));
      p=pstat(p01,m);
      outfile<<x<<"   "<<p<<"\n";
      }
      
   m1=m;
   m2=mach2(m1);
   p02=ptot2(p01,m1);
   
   cout<<"***"<<m1<<"   "<<m2<<" "<<p02<<endl;
   
   for(x=xs;x<10.+0.5*dx;x+=dx)
      {
      a=a_mach(m2)*area(x)/area(xs);   
      m=mach_a(a,0.1);
      p=pstat(p02,m);
      outfile<<x<<" "<<p<<"\n";
      }
   cout<<p<<endl;   
   }
   
double area(double x)
   {
   return 1.+(0.5+(x<5.))*(1.-0.2*x)*(1.-0.2*x);
   }
   
double mach2(double m1)
   {
   return sqrt((1+0.2*m1*m1)/(1.4*m1*m1-0.2));
   }
   
double ptot2(double p01,double m1)
   {
   return p01*pow(1.+7./6.*(m1*m1-1.),-2.5)*pow(1.-5./6.*(1.-1./(m1*m1)),-3.5);
   }
   
double pstat(double p0,double m)
   {
   return p0/pow(1.+0.2*m*m,3.5);
   }
   
double mach_a(double a,double m0)
   {
   double m=m0;
   
   do
      {
      m0=m;
      m=m0+216.*m0*m0*(a-a_mach(m0))/(5.*(m0*m0-1.)*(m0*m0+5.)*(m0*m0+5.));
      }
   while(fabs(m-m0)>1e-6);
   
   return 0.5*(m+m0);
   }

double a_mach(double m)
   {
   return pow(5.+m*m,3.)/(216.*m);
   }
   
