#ifndef SOLVER
#define SOLVER
#include "array.h"

#define max(a,b) (((a)>(b)) ? (a) : (b))

void timestep(Matrix<real>* W, Matrix<real>& x, Matrix<real>& dt);

real Mach(Matrix<real>* W,int i,int j);

void flux1_ij(Matrix<real>* W, int i, int j,real f[4]);

void flux2_ij(Matrix<real>* W, int i, int j,real f[4]);

void boundary(Matrix<real>* W, Matrix<real> flux1[2][4], Matrix<real> flux2[2][4], Matrix<real>& vol);

void Euler_flux(Matrix<real>* W, Matrix<real> flux1[2][4], Matrix<real> flux2[2][4]);

void diff_flux(Matrix<real>* W, Matrix<real>* dflux1, Matrix<real>* dflux2);

void residual(Matrix<real>& vol, Matrix<real>*  surf1, Matrix<real>*  surf2,
                           Matrix<real> flux1[2][4], Matrix<real> flux2[2][4], 
                           Matrix<real>* dflux1, Matrix<real>* dflux2, Matrix<real>* R,Matrix<real>* W);
                           
void march(Matrix<real>* W,   Matrix<real>*   Wold, 
           Matrix<real>& vol, Matrix<real>*  surf1, Matrix<real>*  surf2,
           Matrix<real> flux1[2][4], Matrix<real> flux2[2][4], 
           Matrix<real>* dflux1, Matrix<real>* dflux2, Matrix<real>* R, Matrix<real>& dt);
                        
#include "solver.cc"
#endif                                                     
                                       











